# -*- mode: ruby -*-
# vi: set ft=ruby :

# All Vagrant configuration is done below. The "2" in Vagrant.configure
# configures the configuration version (we support older styles for
# backwards compatibility). Please don't change it unless you know what
# you're doing.
distrib="debian/buster64"
sftp_ip="192.168.56.12"
proxy_ip="192.168.56.13"

Vagrant.configure("2") do |config|
  config.hostmanager.enabled = true
  config.hostmanager.manage_host = true

  config.vm.define 'sftp' do |m|
      m.vm.box = distrib
      m.vm.hostname = 'pknet-sftp.local'
      m.vm.network 'private_network', ip: sftp_ip
      m.vm.synced_folder ".", "/vagrant", disabled: true

      # It's kind of ugly to hardcode this but.. meh. Keep it simple
      m.hostmanager.aliases = ['sftp.pknet.local']

      m.vm.provider 'virtualbox' do |v|
          v.name = 'pknet_sftp'
          v.memory = 1024
          v.cpus = 1
          v.linked_clone = true
          v.gui = false
      end
  end

  config.vm.define 'proxy' do |m|
      m.vm.box = distrib
      m.vm.hostname = 'pknet-proxy.local'
      m.vm.network 'private_network', ip: proxy_ip
      #m.vm.network "forwarded_port", guest: 2000, host: 54321
      m.vm.synced_folder ".", "/vagrant", disabled: true

      # It's kind of ugly to hardcode this but.. meh. Keep it simple
      m.hostmanager.aliases = ['proxy.pknet.local']

      m.vm.provider 'virtualbox' do |v|
          v.name = 'pknet_proxy'
          v.memory = 1024
          v.cpus = 1
          v.linked_clone = true
          v.gui = false
      end
  end

  config.vm.provision "ansible" do |ansible|
     ansible.compatibility_mode = '2.0'
     ansible.playbook = "playbook.yml"
     ansible.inventory_path = 'inventories/pknet/vagrant/hosts.yml'
     ansible.limit = 'all'
     ansible.extra_vars = { ansible_python_interpreter: '/usr/bin/python3' }
     #ansible.inventory_path = '../../inventories/pknet/vagrant/hosts.yml'
     #ansible.extra_vars = { ansible_python_interpreter: '/usr/bin/python3' }
     #ansible.playbook = '../../pknet.yml'
     # ansible.raw_arguments = ['--check']

  end

  # The most common configuration options are documented and commented below.
  # For a complete reference, please see the online documentation at
  # https://docs.vagrantup.com.

  # Every Vagrant development environment requires a box. You can search for
  # boxes at https://vagrantcloud.com/search.
  #config.vm.box = "generic/alpine38"
  # config.vm.box = "debian/buster64"
  #config.vm.box = "generic/ubuntu2004"
  #config.vm.box = "generic/ubuntu1804"

  # Disable automatic box update checking. If you disable this, then
  # boxes will only be checked for updates when the user runs
  # `vagrant box outdated`. This is not recommended.
  # config.vm.box_check_update = false

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine. In the example below,
  # accessing "localhost:8080" will access port 80 on the guest machine.
  # NOTE: This will enable public access to the opened port
  # config.vm.network "forwarded_port", guest: 80, host: 8080

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine and only allow access
  # via 127.0.0.1 to disable public access
  # config.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"

  # Create a private network, which allows host-only access to the machine
  # using a specific IP.
  # config.vm.network "private_network", ip: "192.168.56.12"


  # Create a public network, which generally matched to bridged network.
  # Bridged networks make the machine appear as another physical device on
  # your network.
  # config.vm.network "public_network"

  # Share an additional folder to the guest VM. The first argument is
  # the path on the host to the actual folder. The second argument is
  # the path on the guest to mount the folder. And the optional third
  # argument is a set of non-required options.
  # config.vm.synced_folder ".", "/vagrant", disabled: true
  # config.vm.synced_folder "/tmp/data", "/vagrant_data"

  # Provider-specific configuration so you can fine-tune various
  # backing providers for Vagrant. These expose provider-specific options.
  # Example for VirtualBox:
  #
  # config.vm.provider "virtualbox" do |vb|
  #   # Display the VirtualBox GUI when booting the machine
  #   vb.gui = true
  #
  #   # Customize the amount of memory on the VM:
  #   vb.memory = "1024"
  # end
  #
  # View the documentation for the provider you are using for more
  # information on available options.

  # Enable provisioning with a shell script. Additional provisioners such as
  # Ansible, Chef, Docker, Puppet and Salt are also available. Please see the
  # documentation for more information about their specific syntax and use.
  # config.vm.provision "shell", inline: <<-SHELL
  #   apt-get update
  #   apt-get install -y apache2
  # SHELL
  #config.vm.provision "shell",
  #inline: "echo Hello, World"
  #


end
